Unit aet3e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AA01Z_p, AA02Z_p, UTAE12_p;

procedure aet3e(NM :Integer; N :Integer; var A :Array of Extended;
                var WR :Array of Extended; var WI :Array of Extended;
                var SELECT :Array of Boolean; MM :Integer;
                var M :Integer; var Z :Array of Extended;
                var RM1 :Array of Extended; var RV1 :Array of Extended;
                var RV2 :Array of Extended; var IERR :Integer);

implementation

procedure aet3e(NM :Integer; N :Integer; var A :Array of Extended;
                var WR :Array of Extended; var WI :Array of Extended;
                var SELECT :Array of Boolean; MM :Integer;
                var M :Integer; var Z :Array of Extended;
                var RM1 :Array of Extended; var RV1 :Array of Extended;
                var RV2 :Array of Extended; var IERR :Integer);
var
I,II,IP,IP1,ITS,J,K,KM1,L,MP,N1,NS,S,UK :Integer;
EPS3,EPS4,GROWTO,ILAMBD,NORM,NORMV,RLAMBD,T,UKROOT,W,X,X2,Y :Extended;
LOG :Boolean;
const
SYS051 :Extended = 1.1107652e-16;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220,_230,_240,_250,_260,_270,_280,_290,
_300,_310,_320,_330,_340,_350,_360,_370,_380,_390,_400,_410,_420,_430,
_440,_450,_460,_470,_480,_490,_500,_510,_520,_530,_540,_550,_560,_570,
_580,_590;
begin
{  ***** SYS51 - MAHHO-ABCMA KOHCTAHTA, XAPAKTEPYA OTHOCT. }
{                 TOHOCT APMETK C ABAE ATO }
IERR := 0;
UK := 0;
S := 1;
{ *******IP=,BE. C.H. }
{           1,EPBOE C.H.  KOM.-COP. A }
{          -1,BTOPOE C.H.  KOM.-COP. AP }
IP := 0;
N1 := N - 1;
for K:=1 to N do
 begin
  if ( WI[K-1] =  0.0e0 ) or (  IP <  0 ) 
   then goto _10;
  IP := 1;
  if ( SELECT[K-1] ) and (  SELECT[K+0] ) 
   then SELECT[K+0] := False;
_10:
  LOG := ( not  SELECT[K-1] );
  if ( LOG ) 
   then goto _560;
  if ( WI[K-1] <>  0.0e0 ) 
   then S := S + 1;
  if ( S >  MM ) 
   then goto _580;
  if ( UK >=  K ) 
   then goto _60;
{ *****POBEPKA HA BOMOHOCT PACEEH }
  for UK:=K to N do
   begin
    if ( UK =  N ) 
     then goto _30;
    if ( A[(UK+0)+(UK-1)*NM] =  0.0e0 ) 
     then goto _30;
_20:
   end;
{ *****B-E ECKOHEHO HOPM ABHOO MHOPA OPKA UK }
_30:
  NORM := 0.0e0;
  MP := 1;
  for I:=1 to UK do
   begin
    X := 0.0e0;
    for J:=MP to UK do
     begin
      X := X + Abs(A[(I-1)+(J-1)*NM]);
_40:
     end;
    if ( X >  NORM ) 
     then NORM := X;
    MP := I;
_50:
   end;
{ *****EPS4-BEHA  AMEH MAOO BEYEO EMEHTA }
{      EPS3-BEHA  BOMYEH  .. }
  if ( NORM =  0.0e0 ) 
   then NORM := 1.0e0;
  EPS3 := SYS051*NORM;
  EPS4 := EPS3/2.e0;
{ *****GROWTO -AKTOP POCTA }
  UKROOT := UK;
  UKROOT := Sqrt(UKROOT);
  GROWTO := 1.0e-1/UKROOT;
_60:
  RLAMBD := WR[K-1];
  ILAMBD := WI[K-1];
  if ( K =  1 ) 
   then goto _100;
  KM1 := K - 1;
  goto _80;
{ *****BOMYEHE C.H.,KOTOPOE KO K KAKOMY-O  PEYX }
_70:
  RLAMBD := RLAMBD + EPS3;
{ *****I=K-1,1,-1 }
_80:
  for II:=1 to KM1 do
   begin
    I := K - II;
    if ( SELECT[I-1] ) and (  Abs(WR[I-1] - RLAMBD) < 
         EPS3 ) and (  Abs(WI[I-1] - ILAMBD) <  EPS3 ) 
     then goto _70;
_90:
   end;
  WR[K-1] := RLAMBD;
{ *****COOTBETCTBYEE BOMYEHE KOM.-COP. C.H. }
  IP1 := K + IP;
  WR[IP1-1] := RLAMBD;
_100:
  MP := 1;
  for I:=1 to UK do
   begin
    for J:=MP to UK do
     begin
      RM1[(J-1)+(I-1)*N] := A[(I-1)+(J-1)*NM];
_110:
     end;
    RM1[(I-1)+(I-1)*N] := RM1[(I-1)+(I-1)*N] - RLAMBD;
    MP := I;
    RV1[I-1] := EPS3;
_120:
   end;
  ITS := 0;
  if ( ILAMBD <>  0.0e0 ) 
   then goto _220;
{ *****BE.C.H. }
{      TPEY.PAEHE METOOM AYCCA C EPECTAHOBKAM }
  if ( UK =  1 ) 
   then goto _170;
  for I:=2 to UK do
   begin
    MP := I - 1;
    if ( Abs(RM1[(MP-1)+(I-1)*N]) <=  Abs(RM1[(MP-1)+(MP-1)*N]) )
     then goto _140;
    for J:=MP to UK do
     begin
      Y := RM1[(J-1)+(I-1)*N];
      RM1[(J-1)+(I-1)*N] := RM1[(J-1)+(MP-1)*N];
      RM1[(J-1)+(MP-1)*N] := Y;
_130:
     end;
_140:
    if ( Abs(RM1[(MP-1)+(MP-1)*N]) <=  EPS4 )
     then RM1[(UK-1)+(UK-1)*N] := EPS4;
    X := RM1[(MP-1)+(I-1)*N]/RM1[(MP-1)+(MP-1)*N];
    if ( X =  0.0e0 ) 
     then goto _160;
    for J:=I to UK do
     begin
      RM1[(J-1)+(I-1)*N] := RM1[(J-1)+(I-1)*N] - X*RM1[(J-1)+(MP-1)*N];
_150:
     end;
_160:
   end;
_170:
  if ( Abs(RM1[(UK-1)+(UK-1)*N]) <=  EPS4 ) 
   then RM1[(UK-1)+(UK-1)*N] := EPS4;
{ *****OPATHA OCTAHOBKA  BE. C.B. }
{       I=UK,1,-1 }
_180:
  for II:=1 to UK do
   begin
    I := UK + 1 - II;
    Y := RV1[I-1];
    if ( I =  UK ) 
     then goto _200;
    IP1 := I + 1;
    for J:=IP1 to UK do
     begin
      Y := Y - RM1[(J-1)+(I-1)*N]*RV1[J-1];
_190:
     end;
_200:
    RV1[I-1] := Y/RM1[(I-1)+(I-1)*N];
_210:
   end;
  goto _450;
{ *****KOM. C. H. }
{      TPEY.PAOEHE METOOM AYCCA C EPECTAHOBKAM }
{      EPS4-BEHA  AMEH HYEBOO BE.MEHTA }
{      MHMA ACT AOMHAETC B BEPXHEM TPEYOHKE, }
{      HAHA C O (1,3) ***** }
_220:
  NS := N - S;
  Z[0+(S-2)*NM] := -ILAMBD;
  Z[0+(S-1)*NM] := 0.0e0;
  if ( N =  2 ) 
   then goto _240;
  RM1[0+2*N] := -ILAMBD;
  Z[0+(S-2)*NM] := 0.0e0;
  if ( N =  3 ) 
   then goto _240;
  for I:=4 to N do
   begin
    RM1[0+(I-1)*N] := 0.0e0;
_230:
   end;
_240:
  for I:=2 to UK do
   begin
    MP := I - 1;
    W := RM1[(MP-1)+(I-1)*N];
    if ( I <  N ) 
     then T := RM1[(MP-1)+(I+0)*N];
    if ( I =  N ) 
     then T := Z[(MP-1)+(S-2)*NM];
    X2 := AA01Z(RM1[(MP-1)+(MP-1)*N],T);
    if ( W <=  X2 ) 
     then goto _280;
    X := RM1[(MP-1)+(MP-1)*N]/W;
    Y := T/W;
    RM1[(MP-1)+(MP-1)*N] := W;
    if ( I <  N ) 
     then RM1[(MP-1)+(I+0)*N] := 0.0e0;
    if ( I =  N ) 
     then Z[(MP-1)+(S-2)*NM] := 0.0e0;
    for J:=I to UK do
     begin
      W := RM1[(J-1)+(I-1)*N];
      RM1[(J-1)+(I-1)*N] := RM1[(J-1)+(MP-1)*N] - X*W;
      RM1[(J-1)+(MP-1)*N] := W;
      if ( J <  N1 ) 
       then goto _250;
      L := J - NS;
      Z[(I-1)+(L-1)*NM] := Z[(MP-1)+(L-1)*NM] - Y*W;
      Z[(MP-1)+(L-1)*NM] := 0.0e0;
      goto _260;
_250:
      RM1[(I-1)+(J+1)*N] := RM1[(MP-1)+(J+1)*N] - Y*W;
      RM1[(MP-1)+(J+1)*N] := 0.0e0;
_260:
     end;
    RM1[(I-1)+(I-1)*N] := RM1[(I-1)+(I-1)*N] - Y*ILAMBD;
    if ( I <  N1 ) 
     then goto _270;
    L := I - NS;
    Z[(MP-1)+(L-1)*NM] := -ILAMBD;
    Z[(I-1)+(L-1)*NM] := Z[(I-1)+(L-1)*NM] + X*ILAMBD;
    goto _340;
_270:
    RM1[(MP-1)+(I+1)*N] := -ILAMBD;
    RM1[(I-1)+(I+1)*N] := RM1[(I-1)+(I+1)*N] + X*ILAMBD;
    goto _340;
_280:
    if ( X2 >  EPS4 ) 
     then goto _290;
    RM1[(MP-1)+(MP-1)*N] := EPS4;
    if ( I <  N ) 
     then RM1[(MP-1)+(I+0)*N] := 0.0e0;
    if ( I =  N ) 
     then Z[(MP-1)+(S-2)*NM] := 0.0e0;
    T := 0.0e0;
    X2 := EPS4;
_290:
    W := (W/X2)/X2;
    X := RM1[(MP-1)+(MP-1)*N]*W;
    Y := -T*W;
    for J:=I to UK do
     begin
      if ( J <  N1 ) 
       then goto _300;
      L := J - NS;
      T := Z[(MP-1)+(L-1)*NM];
      Z[(I-1)+(L-1)*NM] := -X*T - Y*RM1[(J-1)+(MP-1)*N];
      goto _310;
_300:
      T := RM1[(MP-1)+(J+1)*N];
      RM1[(I-1)+(J+1)*N] := -X*T - Y*RM1[(J-1)+(MP-1)*N];
_310:
      RM1[(J-1)+(I-1)*N] := RM1[(J-1)+(I-1)*N] - X*RM1[(J-1)+(MP-1)*N] + Y*T;
_320:
     end;
    if ( I <  N1 ) 
     then goto _330;
    L := I - NS;
    Z[(I-1)+(L-1)*NM] := Z[(I-1)+(L-1)*NM] - ILAMBD;
    goto _340;
_330:
    RM1[(I-1)+(I+1)*N] := RM1[(I-1)+(I+1)*N] - ILAMBD;
_340:
   end;
  if ( UK <  N1 ) 
   then goto _350;
  L := UK - NS;
  T := Z[(UK-1)+(L-1)*NM];
  goto _360;
_350:
  T := RM1[(UK-1)+(UK+1)*N];
_360:
  if ( Abs(RM1[(UK-1)+(UK-1)*N]) <=  EPS4 ) and (  Abs(T) <=  EPS4 )
   then RM1[(UK-1)+(UK-1)*N] := EPS4;
{ *****OPATHA OCTAHOBKA  KOM.C.B. }
{      I=,UK,1,-1 }
_370:
  for II:=1 to UK do
   begin
    I := UK + 1 - II;
    X := RV1[I-1];
    Y := 0.0e0;
    if ( I =  UK ) 
     then goto _410;
    IP1 := I + 1;
    for J:=IP1 to UK do
     begin
      if ( J <  N1 ) 
       then goto _380;
      L := J - NS;
      T := Z[(I-1)+(L-1)*NM];
      goto _390;
_380:
      T := RM1[(I-1)+(J+1)*N];
_390:
      X := X - RM1[(J-1)+(I-1)*N]*RV1[J-1] + T*RV2[J-1];
      Y := Y - RM1[(J-1)+(I-1)*N]*RV2[J-1] - T*RV1[J-1];
_400:
     end;
_410:
    if ( I <  N1 ) 
     then goto _420;
    L := I - NS;
    T := Z[(I-1)+(L-1)*NM];
    goto _430;
_420:
    T := RM1[(I-1)+(I+1)*N];
_430:
    AA02Z(X,Y,RM1[(I-1)+(I-1)*N],T,RV1[I-1],RV2[I-1]);
_440:
   end;
{ *****POBEPKA BCEHHOO C.B.  EO HOPMPOBKA }
_450:
  ITS := ITS + 1;
  NORM := 0.0e0;
  NORMV := 0.0e0;
  for I:=1 to UK do
   begin
    if ( ILAMBD =  0.0e0 ) 
     then X := Abs(RV1[I-1]);
    if ( ILAMBD <>  0.0e0 ) 
     then X := AA01Z(RV1[I-1],RV2[I-1]);
    if ( NORMV >=  X ) 
     then goto _460;
    NORMV := X;
    J := I;
_460:
    NORM := NORM + X;
_470:
   end;
  if ( NORM <  GROWTO ) 
   then goto _500;
{ *****EMEM BEKTOP***** }
  X := RV1[J-1];
  if ( ILAMBD =  0.0e0 ) 
   then X := 1.0e0/X;
  if ( ILAMBD <>  0.0e0 ) 
   then Y := RV2[J-1];
  for I:=1 to UK do
   begin
    if ( ILAMBD <>  0.0e0 ) 
     then goto _480;
    Z[(I-1)+(S-1)*NM] := RV1[I-1]*X;
    goto _490;
_480:
    AA02Z(RV1[I-1],RV2[I-1],X,Y,Z[(I-1)+(S-2)*NM],Z[(I-1)+(S-1)*NM]);
_490:
   end;
  if ( UK =  N ) 
   then goto _550;
  J := UK + 1;
  goto _530;
{ *****OCTPOEHE HOBOO HAAHOO B. }
_500:
  if ( ITS >=  UK ) 
   then goto _520;
  X := UKROOT;
  Y := EPS3/(X + 1.0e0);
  RV1[0] := EPS3;
  for I:=2 to UK do
   begin
    RV1[I-1] := Y;
_510:
   end;
  J := UK - ITS + 1;
  RV1[J-1] := RV1[J-1] - EPS3*X;
  if ( ILAMBD =  0.0e0 ) 
   then goto _180;
  goto _370;
{ *****ATAHA OKA:HE O OYEHO EMEMOO C.B. }
_520:
  J := 1;
  IERR := -K;
{ *****CBABAHE HYEBX HAEH OCTABMC KOMOHEHTAM }
_530:
  for I:=J to N do
   begin
    Z[(I-1)+(S-1)*NM] := 0.0e0;
    if ( ILAMBD <>  0.0e0 ) 
     then Z[(I-1)+(S-2)*NM] := 0.0e0;
_540:
   end;
_550:
  S := S + 1;
_560:
  if ( IP =  (-1) ) 
   then IP := 0;
  if ( IP =  1 ) 
   then IP := -1;
_570:
 end;
goto _590;
{ *****ATAHA OKA: CTOOB MACCBA Z HE XBATAET  PAMEEH }
{      BCEX TPEYEMX C.B.****** }
_580:
if ( IERR <>  0 ) 
 then IERR := IERR - N;
if ( IERR =  0 ) 
 then IERR := -(2*N + 1);
_590:
M := S - 1 - Abs(IP);
if ( IERR <>  0 ) 
 then UTAE12(IERR,N,9);
end;

end.
